/*
 * Copyright (c) 2002-2006, Sergey Kirshner and the Regents of 
 * the University of California
 * All rights reserved.
 *
 * This software is open-source under the BSD license; see "LICENSE"
*/

/* mvnhmm.h */
#include "struct.h"

/* Variables */
Parameters* params;               // Parameters for the file
HMM* theta=NULL;                  // Parameters of the HMM
Data* output_data=NULL;           // Data for the output variables
Data* input_data=NULL;            // Data for the input variables
Data* extra_data=NULL;            // Extra data
HMM** passed_theta=NULL;          // Parameters from the model file

FILE* data_file=NULL;             // Data file
FILE* input_file=NULL;            // Input file
FILE* extra_file=NULL;            // Extra data file
FILE* output_file=NULL;           // Output file
FILE* model_file=NULL;            // File with values of parameters for the model
FILE* state_output_file=NULL;     // File to write states to

long num_failed;                  // Number of failed runs

#ifdef TEMPDISABLED
double cl_threshold;              // Chow-Liu mutual information threshold !!! !!!
#endif

extern long robust_first_state;

double cg_epsilon;
double maxent_epsilon;

/* Functions */
void ProcessParameters( void );
void AdjustSelectionPrior( double**, long, Data*, long );
void test( void );
