/*
Copyright (c) 2006. The Regents of Columbia University, All Rights Reserved.
 
Permission to use, copy and distribute this software and its documentation 
for any purpose, without fee, and without a written agreement, is hereby granted, 
provided that the above copyright notice, this paragraph and the following two 
paragraphs appear in all copies and distributions.  

Created by Lulin Song, 
           International Research Institute Society,
           Columbia University

                       
REGENTS SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A  PARTICULAR PURPOSE. THE SOFTWARE AND ACCOMPANYING DOCUMENTATION,
IF ANY, PROVIDED HEREUNDER IS PROVIDED "AS IS". REGENTS HAS
NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
MODIFICATIONS.
*/

#ifndef WIND_EXTRA_H
#define WIND_EXTRA_H

/* Define some routines or macros which don't exist in Windows.
 *  @author Lulin Song (International Research Institute For Climate Society, Columbia University)
 */

#ifdef WIN32
#include <float.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#define isnan(x) _isnan(x)
#define finite(x) _finite(x)
#define strcpy(x,y) strcpy_s(x,y) //strcpy is depreciated on Windows

#define drand48() drand16() //16 bits precision

#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif

/** functions */
double drand16();
void srand48(time_t x=0);

void getWindowFileName( char* filename);

#endif

#endif
